//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "_29_Unit1.h"
#include "_29_Unit2.h"
#include <fstream.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

const char *SOUBOR = "topten.txt";
const char HRAC1 = 0;   //mus takhle bt
const char HRAC2 = 1;
const char NIC = 10;

template<class T>
   inline T abs(T a) { return a>0 ? a : -a; }
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner), pole(0), rozmer(0)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Konec1Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
//startuje novou hru
void __fastcall TForm1::Nov1Click(TObject *Sender)
{
   String sdim = InputBox("Nov hra", "Zadej romr hracho pole:", "3");
   int dim = sdim.ToIntDef(0);
   if(dim < 2 || dim > 10) {
      Application->MessageBox("Rozmr m bt od 2 do 10", "Chyba", MB_OK | MB_ICONHAND);
      return;
   }

   rozmer = dim;
   pole = new char *[2*rozmer+1];                    //vytvome matici
   for(int i = 0; i < 2*rozmer+1; i++) {
      pole[i] = new char[rozmer+1];
      memset(pole[i], NIC, (rozmer+1));
   }
   ximag = yimag = typ = 0;
   skore[HRAC1] = skore[HRAC2] = 0;
   DrawGrid1->RowCount = rozmer;
   DrawGrid1->ColCount = rozmer;
   Skore1->Caption = "0";
   Skore2->Caption = "0";
   hraje=HRAC1;
   StatusBar1->SimpleText = "Hra .1 polo zpalku";
   DrawGrid1->Cursor = crHandPoint;
   DrawGrid1->Canvas->FillRect(ClientRect);
   DrawGrid1->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   if(pole) for(int i = 0; i < 2*rozmer+1; i++) delete [] pole[i];
   delete [] pole;
}
//---------------------------------------------------------------------------
//kreslen kad buky mky
void __fastcall TForm1::DrawGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
   if(!pole) return;

   TCanvas *C = DrawGrid1->Canvas;
   C->Brush->Color = clRed;
   if(Plne(HRAC1, ARow, ACol)) C->FillRect(Rect);
   C->Brush->Color = clYellow;
   if(Plne(HRAC2, ARow, ACol)) C->FillRect(Rect);
   Sirky(Rect, ARow, ACol);
   if(ximag==ACol && yimag==ARow) Imag(Rect);
}
//---------------------------------------------------------------------------
//nakresl sirky do rect podle pole
void TForm1::Sirky(TRect rect, int y, int x) {
   TCanvas *C = DrawGrid1->Canvas;
   C->Pen->Color = clBlack;
   C->Pen->Width = 1;
   int X = rect.Left, Y = rect.Top, X2 = rect.Right, Y2 = rect.Bottom;

   y *= 2;
   C->Brush->Color = clRed;
   if(pole[y+1][x]==HRAC1) C->Rectangle(X-2, Y+2, X+2, Y2-2);
   if(pole[y][x]==HRAC1) C->Rectangle(X+2, Y-2, X2-2, Y+2);
   if(pole[y+1][x+1]==HRAC1) C->Rectangle(X2-2, Y+2, X2+2, Y2-2);
   if(pole[y+2][x]==HRAC1) C->Rectangle(X+2, Y2-2, X2-2, Y2+2);

   C->Brush->Color = clYellow;
   if(pole[y+1][x]==HRAC2) C->Rectangle(X-2, Y+2, X+2, Y2-2);
   if(pole[y][x]==HRAC2) C->Rectangle(X+2, Y-2, X2-2, Y+2);
   if(pole[y+1][x+1]==HRAC2) C->Rectangle(X2-2, Y+2, X2+2, Y2-2);
   if(pole[y+2][x]==HRAC2) C->Rectangle(X+2, Y2-2, X2-2, Y2+2);
}
//-----------------------------
void __fastcall TForm1::DrawGrid1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if(Button == mbLeft) {
      if(!pole) { Nov1Click(Sender); return; }

      int x = X/DrawGrid1->DefaultColWidth, y = 2 * (Y/DrawGrid1->DefaultRowHeight);
      int modx = X%DrawGrid1->DefaultColWidth, mody = Y%DrawGrid1->DefaultRowHeight;
      bool vlevo=true, nahore=true;
      if(abs(DrawGrid1->DefaultColWidth-modx) < modx) {
         modx = abs(DrawGrid1->DefaultColWidth-modx);
         vlevo = false;
      }
      if(abs(DrawGrid1->DefaultRowHeight-mody) < mody) {
         mody = abs(DrawGrid1->DefaultRowHeight-mody);
         nahore = false;
      }
      if(modx > DrawGrid1->DefaultColWidth/10 && mody > DrawGrid1->DefaultRowHeight/10) return;

      if(modx < mody) {   //polome vertikln
         if(!vlevo) x++;
         y++;
/*         ShowMessage(String("x,y = " + IntToStr(x) + "," + IntToStr(y) + "\nmodx,mody = " + IntToStr(modx) + "," + IntToStr(mody) +
            "\nvlevo,nahore = " + IntToStr(vlevo) + "," + IntToStr(nahore)));*/
      }
      else {               //resp. horizontln
         if(!nahore) y += 2;
/*         ShowMessage(String("x,y = " + IntToStr(x) + "," + IntToStr(y) + "\nmodx,mody = " + IntToStr(modx) + "," + IntToStr(mody) +
            "\nvlevo,nahore = " + IntToStr(vlevo) + "," + IntToStr(nahore)));*/
      }
      if(pole[y][x]==NIC) pole[y][x] = hraje;
      else return;

      y = Y/DrawGrid1->DefaultRowHeight; x = X/DrawGrid1->DefaultColWidth;
      if(y >= rozmer) y=rozmer-1;
      if(x >= rozmer) x=rozmer-1;
      if(!Plne(hraje, y, x)) {
         if(hraje==HRAC1) hraje=HRAC2;
         else hraje=HRAC1;
      }
      else skore[hraje]++;
      Testy();
      DrawGrid1->Repaint();
   }
}
//-------------------------------------
bool TForm1::Plne(char koho, int y, int x) {
   return pole[2*y+1][x]==koho &&
      pole[2*y][x]==koho &&
      pole[2*y+1][x+1]==koho &&
      pole[2*y+2][x]==koho;
}

//----------------------------
void TForm1::Testy() {
   StatusBar1->SimpleText = "Hr ." + String((int)hraje+1) + " polo zpalku";
   Skore1->Caption = skore[HRAC1];
   Skore2->Caption = skore[HRAC2];
   for(int i = 0; i < 2*rozmer+1; i++) {
      if((i&1)==0 && memchr(pole[i], NIC, rozmer)) return;
      else if((i&1) && memchr(pole[i], NIC, rozmer+1)) return;
   }
   //konme hru
   Application->MessageBox(String("Skre: "+IntToStr(skore[HRAC1]) + " : " + IntToStr(skore[HRAC2])).c_str(), "Konec hry", MB_OK | MB_ICONINFORMATION);
   ifstream fi(SOUBOR);
   int j=0, N=0;
   struct TMAX {
      char jm[20];
      int m;
   } maxy[10];
   for(int i = 0; i < 10; i++) maxy[i].m = 0;
   if(fi) {
      while(!fi.eof()) {
         fi.getline(maxy[j].jm, 20, '\n');
         if(!fi.eof()) {
            fi >> maxy[j].m;
            fi.ignore();
            j++;
            N = j;
         }
      }
   }
   j = HRAC1;
   if(skore[HRAC2] > skore[HRAC1]) j = HRAC2;

   if(N < 10) N++;
   else if(skore[j] > maxy[N-1].m);
   else return;
   maxy[N-1].m = skore[j];
   String jme = InputBox("Zpis do Top Ten", "Zadej svoje jmno:", "");
   strcpy(maxy[N-1].jm, jme.c_str());

      //setdme
      for(int k = 0; k < N-1; k++) {
         int bude, budemax=0;
         for(int l = k+1; l < N; l++)
            if(budemax < maxy[l].m) { budemax = maxy[l].m; bude = l; }
         if(bude != k) {
            TMAX sk = maxy[k];
            maxy[k] = maxy[bude];
            maxy[bude] = sk;
         }
      }


      ofstream f(SOUBOR, ios_base::trunc);
      if(f) {
         for(int i = 0; i < N; i++) {
            f << maxy[i].jm << "\n";
            f << maxy[i].m << "\n";
         }
      }

   for(int i = 0; i < 2*rozmer+1; i++) {
      memset(pole[i], NIC, (rozmer+1));
   }
   skore[HRAC1] = skore[HRAC2] = 0;
   Skore1->Caption = "0";
   Skore2->Caption = "0";
   hraje=HRAC1;
   StatusBar1->SimpleText = "Hra .1 polo zpalku";
   DrawGrid1->Cursor = crHandPoint;
   DrawGrid1->Canvas->FillRect(DrawGrid1->ClientRect);
   DrawGrid1->Repaint();
}
//---------------------------------
void __fastcall TForm1::TopTen1Click(TObject *Sender)
{
   Form2->ListBox1->Items->Clear();
   ifstream f(SOUBOR);
   if(f) {
      char buf[100];
      int j = 0;
      String str;
      while(!f.eof()) {
         f.getline(buf, 99, '\n');
         if((j&1)==0) {
            for(int i = strlen(buf); i < 20; i++) strcat(buf, " ");
            str = buf;
         }
         else {
            str += String(buf);
            Form2->ListBox1->Items->Add(str);
         }
         j++;
      }
      Form2->ShowModal();
   }
   else {
      ofstream fu(SOUBOR);
      Application->MessageBox("V Top Ten dosud nen nikdo", "Informace", MB_OK);
   }
}
//---------------------------------------------------------------------------
void TForm1::Imag(TRect rect) {
   TCanvas *C = DrawGrid1->Canvas;
   C->Brush->Color = clGray;
   C->Pen->Width = 1;
   int X = rect.Left, Y = rect.Top, X2 = rect.Right, Y2 = rect.Bottom;

   switch(typ) {
      case 0: C->FrameRect(TRect(X-2, Y+2, X+2, Y2-2)); break;
      case 1: C->FrameRect(TRect(X+2, Y-2, X2-2, Y+2)); break;
      case 2: C->FrameRect(TRect(X2-2, Y+2, X2+2, Y2-2)); break;
      case 3: C->FrameRect(TRect(X+2, Y2-2, X2-2, Y2+2)); break;
   }
}
//----------------------------------------------------
void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
   DrawGrid1->Canvas->FillRect(ClientRect);
   switch(Key) {
      case VK_LEFT:
         ximag--;
         if(ximag < 0) ximag = rozmer-1;
         break;
      case VK_RIGHT:
         ximag++;
         if(ximag >= rozmer) ximag = 0;
         break;
      case VK_UP:
         yimag--;
         if(yimag < 0) yimag = rozmer-1;
         break;
      case VK_DOWN:
         yimag++;
         if(yimag >= rozmer) yimag = 0;
         break;
      case VK_SPACE:
         if(++typ >= 4) typ = 0;
         break;
      case VK_RETURN:
         {
            int y = yimag*2, x=ximag;
            if(typ==0) y++;
            else if(typ==1);
            else if(typ==2) { y++; x++; }
            else if(typ==3) y += 2;

            if(pole[y][x]==NIC) pole[y][x] = hraje;
            else return;

            if(!Plne(hraje, yimag, ximag)) {
               if(hraje==HRAC1) hraje=HRAC2;
               else hraje=HRAC1;
            }
            else skore[hraje]++;
            Testy();
         }
         break;
   }
   DrawGrid1->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Oprogramu1Click(TObject *Sender)
{
   if(!pole) { Nov1Click(Sender); return; }
   //zkusme naped zabrnit protihrovi
   char nehraje = HRAC1;
   if(hraje==nehraje) nehraje = HRAC2;
   for(int y = 0; y < rozmer; y++)
      for(int x = 0; x < rozmer; x++) {
         int px=x, py=y;
         if(JdeDoplnit(nehraje, py, px)) { pole[py][px] = hraje; goto ano; }
      }
   //sami si doplnme
   for(int y = 0; y < rozmer; y++)
      for(int x = 0; x < rozmer; x++) {
         int px=x, py=y;
         if(JdeDoplnit(hraje, py, px)) {
            pole[py][px] = hraje;
            if(Plne(hraje, y, x)) skore[hraje]++;
            goto ano;
         }
      }
   Application->MessageBox("pora si sm!\n(Vyloen ance neexistuje)", "Hra", MB_OK);
   return;
   ano:
   char hr=hraje;
   hraje=nehraje;
   nehraje=hr;
   Testy();
   DrawGrid1->Repaint();
}
//---------------------------------------------------------------------------
bool TForm1::JdeDoplnit(char komu, int &y, int &x) {
   int pocet = (int)(pole[2*y+1][x]==komu) +
      (int)(pole[2*y][x]==komu) +
      (int)(pole[2*y+1][x+1]==komu) +
      (int)(pole[2*y+2][x]==komu);

   if(pocet != 3) return false;
   if(pole[2*y+1][x]==NIC) { y = 2*y+1; return true; }
   if(pole[2*y][x]==NIC) { y = 2*y; return true; }
   if(pole[2*y+1][x+1]==NIC) { y = 2*y+1; x = x+1; return true; }
   if(pole[2*y+2][x]==NIC) { y = 2*y+2; return true; }
   return false;
}
